import { Facet, combineConfig } from '@codemirror/state';
export var completionConfig = Facet.define({
  combine: function combine(configs) {
    return combineConfig(configs, {
      activateOnTyping: true,
      selectOnOpen: true,
      override: null,
      closeOnBlur: true,
      maxRenderedOptions: 100,
      defaultKeymap: true,
      optionClass: function optionClass() {
        return '';
      },
      aboveCursor: false,
      icons: true,
      addToOptions: [],
      compareCompletions: function compareCompletions(a, b) {
        return a.label.localeCompare(b.label);
      },
      interactionDelay: 75
    }, {
      defaultKeymap: function defaultKeymap(a, b) {
        return a && b;
      },
      closeOnBlur: function closeOnBlur(a, b) {
        return a && b;
      },
      icons: function icons(a, b) {
        return a && b;
      },
      optionClass: function optionClass(a, b) {
        return function (c) {
          return joinClass(a(c), b(c));
        };
      },
      addToOptions: function addToOptions(a, b) {
        return a.concat(b);
      }
    });
  }
});
function joinClass(a, b) {
  return a ? b ? a + ' ' + b : a : b;
}