function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
/* eslint-disable prefer-const */
/* eslint-disable @typescript-eslint/no-shadow */
var C = /*#__PURE__*/function (C) {
  C[C["Range"] = 50000] = "Range";
  C[C["MinCacheLen"] = 1000] = "MinCacheLen";
  C[C["MaxList"] = 2000] = "MaxList";
  return C;
}(C || {});
function wordRE(wordChars) {
  var escaped = wordChars.replace(/[\\[.+*?(){|^$]/g, '\\$&');
  try {
    return new RegExp("[\\p{Alphabetic}\\p{Number}_".concat(escaped, "]+"), 'ug');
  } catch (_unused) {
    // eslint-disable-next-line no-useless-escape
    return new RegExp("[w".concat(escaped, "]"), 'g');
  }
}
function mapRE(re, f) {
  return new RegExp(f(re.source), re.unicode ? 'u' : '');
}
var wordCaches = Object.create(null);
function wordCache(wordChars) {
  return wordCaches[wordChars] || (wordCaches[wordChars] = new WeakMap());
}
function storeWords(doc, wordRE, result, seen, ignoreAt) {
  for (var lines = doc.iterLines(), pos = 0; !lines.next().done;) {
    var value = lines.value,
      m = void 0;
    wordRE.lastIndex = 0;
    while (m = wordRE.exec(value)) {
      if (!seen[m[0]] && pos + m.index !== ignoreAt) {
        result.push({
          type: 'text',
          label: m[0]
        });
        seen[m[0]] = true;
        if (result.length >= C.MaxList) {
          return;
        }
      }
    }
    pos += value.length + 1;
  }
}
function collectWords(doc, cache, wordRE, to, ignoreAt) {
  var big = doc.length >= C.MinCacheLen;
  var cached = big && cache.get(doc);
  if (cached) {
    return cached;
  }
  var result = [],
    seen = Object.create(null);
  if (doc.children) {
    var pos = 0;
    var _iterator = _createForOfIteratorHelper(doc.children),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var ch = _step.value;
        if (ch.length >= C.MinCacheLen) {
          var _iterator2 = _createForOfIteratorHelper(collectWords(ch, cache, wordRE, to - pos, ignoreAt - pos)),
            _step2;
          try {
            for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
              var c = _step2.value;
              if (!seen[c.label]) {
                seen[c.label] = true;
                result.push(c);
              }
            }
          } catch (err) {
            _iterator2.e(err);
          } finally {
            _iterator2.f();
          }
        } else {
          storeWords(ch, wordRE, result, seen, ignoreAt - pos);
        }
        pos += ch.length + 1;
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  } else {
    storeWords(doc, wordRE, result, seen, ignoreAt);
  }
  if (big && result.length < C.MaxList) {
    cache.set(doc, result);
  }
  return result;
}

/// A completion source that will scan the document for words (using a
/// [character categorizer](#state.EditorState.charCategorizer)), and
/// return those as completions.
export var completeAnyWord = function completeAnyWord(context) {
  var wordChars = context.state.languageDataAt('wordChars', context.pos).join('');
  var re = wordRE(wordChars);
  var token = context.matchBefore(mapRE(re, function (s) {
    return s + '$';
  }));
  if (!token && !context.explicit) {
    return null;
  }
  var from = token ? token.from : context.pos;
  var options = collectWords(context.state.doc, wordCache(wordChars), re, C.Range, from);
  return {
    from: from,
    options: options,
    validFor: mapRE(re, function (s) {
      return '^' + s;
    })
  };
};